;filename HICLEAR.ASM - file to release HMA after running HICOPY.COM
;Released into the Public Domain - November/88 by D. Roy

CODE		SEGMENT PARA PUBLIC 'CODE'
		ASSUME	CS:CODE, DS:CODE ;-----------------------------;
		ORG	100H		 ;COM file format! Remember to ;
					 ; use EXE2BIN                 ;
START:					 ;-----------------------------;
	JMP	XMSTEST
;data area
XMSControl	DD	?
NODRIVER_MSG	DB	'No XMS driver installed!...$'
BADVERS_MSG	DB	'Requires Version 2.X XMS Driver!...$'
RELEASED_MSG	DB	'HMA released...',10,13,'$'

;code area
XMSTEST:
	MOV	AX,4300h
	INT	2Fh
	CMP	AL,80h
	LEA	DX,NODRIVER_MSG
	JNE	ERROR_EXIT
;get address of control driver function
	MOV	AX,4310h
	INT	2Fh
	MOV	WORD PTR [XMSControl],BX
	MOV	WORD PTR [XMSControl+2],ES
;get driver's version number
	MOV	AH,00
	CALL	[XMSControl]
	CMP	AH,2
	LEA	DX,BADVERS_MSG
	JNE	ERROR_EXIT
;disable the A20 address line
	MOV	AH,4
	CALL	[XMSControl]
;and release the HMA
	MOV	AH,2
	CALL	[XMSControl]
	LEA	DX,RELEASED_MSG
ERROR_EXIT:
	CALL	WRITE_STRING
EXIT:	INT	20h

;-- subroutines ---------------

WRITE_STRING	PROC	NEAR
	MOV	AH,9
	INT	21h
	RET
WRITE_STRING	ENDP

CODE		ENDS
	END	START
